/* NOTE: we added the following simple method to get dis fieldinto ClientSocket
   .java class
          
   public DataInputStream DIStream()
   {
     return dis;
   }
*/  

package webflow.frontend.ModuleControls;
import webflow.appletsocket.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class URLControl extends controls {

  String message;

  public URLControl(String host, int port) {
    super(host,port);
     
    System.out.println("Initializing URLControl !!!!");
    
    setLayout(new GridLayout(10,1));
    setBackground(Color.cyan);

    add(new Label("Receive URL from backend module",Label.CENTER));
    add(new Label("and show it",Label.CENTER));
    add(new Label("in seperate framw",Label.CENTER));

    //start new thread to get urlfileName
    new receiveURL(this).start();
    
  }

  public void run(){}


}


class receiveURL extends Thread
{
  ClientSocket socket=null;
  DataInputStream dis;
  NetworkClassLoader CLoader;
  URLControl parent;
  
public receiveURL(URLControl parent_)
  {
    
    //socket = socket_;
    //dis    = socket.DIStream();
    parent = parent_;
    //CLoader = new NetworkClassLoader(Host,Port);
  }
  
public void run()
  {
    //wait until I have valid socket
    while(parent.socket == null);
    socket = parent.socket;
    dis    = socket.DIStream();
    System.out.println("Before constructing NetworkClassLoader ");
    
    CLoader = new NetworkClassLoader(parent.host,parent.port);
    System.out.println("After constructing NetworkClassLoader ");

    /* wait until classfileName comes */
    try{
      while (dis.available() == 0);
    }catch(IOException e){
      System.out.println("IOExc: in while");
    }
    
    String className = socket.receive();
    System.out.println("Received class name :"+className);

    Class recvClass = null;
    try{
      recvClass = CLoader.loadClass(className);
    }catch(ClassNotFoundException  e){
      System.out.println("ClassNotFoundException :"+className);
    }
    
    //instantiate this class and load it into separete frame and show it  
    Frame frame=null;
    try{
      frame = (Frame)recvClass.newInstance() ;
    }catch (IllegalAccessException e){
      System.out.println("IllegalAccessException :"+className+": "+e);
    }
    catch(InstantiationException e){
      System.out.println("InstantiationException :"+className+": "+e);
    }
   
    //Frame frame = new Frame();
    //frame.add(panel);
    frame.pack();
    frame.show();
    

  }

}

class NetworkClassLoader extends ClassLoader {
    commProxy proxy;
  
    /** The constructor.  Just initialize the directory */
    public NetworkClassLoader(String Host,int Port) 
    {  
      proxy = new commProxy(Host);
      System.out.println("NetworkClassLoader:after commproxy ");
      setDocumentRootAtServer(Host,Port);
      System.out.println("NetworkClassLoader:after setdocumentroot");
      
    }
  

    /** A convenience method that calls the 2-argument form of this method */
    public Class loadClass(String name) throws ClassNotFoundException { 
      return loadClass(name, true); 
    }

    public void setDocumentRootAtServer(String Host,int Port)
  {
    String sin;

    System.out.println("setDocumentRootAtServer:host"+Host+" Port:"+Port);
    
    try{
      String portReq = "http://"+Host+":"+Port+"/servlet/portservlet";
      URL url = new URL(portReq);
      DataInputStream dis = new DataInputStream( url.openStream() );
      while((sin = dis.readLine()) != null)
        System.out.println("sin :"+sin);
    }catch(MalformedURLException e){
      System.out.println("Malformed URL. Exception " + e + " raised!");
    }
    catch(IOException e) {
        System.out.println("IO exception occured. " + e);
    }
 
  }


    /**
     * This is one abstract method of ClassLoader that all subclasses must
     * define.  Its job is to load an array of bytes from somewhere and to
     * pass them to defineClass().  If the resolve argument is true, it must
     * also call resolveClass(), which will do things like verify the presence
     * of the superclass.  Because of this second step, this method may be
     * called to load superclasses that are system classes, and it must take 
     * this into account.
     **/
    public Class loadClass(String classname, boolean resolve) 
      throws ClassNotFoundException {
      try {
        // Our ClassLoader superclass has a built-in cache of classes it has
        // already loaded.  So, first check the cache.
        Class c = findLoadedClass(classname);

        if (c == null) {
          String filename = classname.replace('.',File.separatorChar)+".class";

	  //send filename to port servlet
	  proxy.send("GetClassBytes"+filename);
	  byte[] classbytes = (byte[])proxy.receive();
	  
          // Now call an inherited method to convert those bytes into a Class
          c = defineClass(classname, classbytes, 0, classbytes.length);
        }

        // If the resolve argument is true, call the inherited resolveClass
        // method.
        if (resolve) resolveClass(c);

        // And we're done.  Return the Class object we've loaded.
        return c;
      }
      // If anything goes wrong, throw a ClassNotFoundException error
      catch (Exception e) { throw new ClassNotFoundException(e.toString()); }
    }
  }

class commProxy
{
  Socket socket;
  ObjectInputStream dis;
  ObjectOutputStream dos;
  
  public commProxy (String Host)
  {
    int Port = 5505;
    
    try{
      socket = new Socket(Host,Port);
      dis = new ObjectInputStream(socket.getInputStream());
      dos = new ObjectOutputStream(socket.getOutputStream());
    }catch(IOException  e){
      System.out.println("IOException in commProxy Init "+e);
    }
    System.out.println("initialized commProxy !!!");
    
    
  }
  
  public void send(Object message)
  {
    System.out.println("Outgoing String:"+message);
    try{
      dos.writeObject(message);
      dos.flush();
    }catch(OptionalDataException e){
      System.out.println("sendWFECommand "+e);
    }catch(IOException e){
      System.out.println("sendWFECommand "+e);
    }
  }

  public Object receive()
  {
    Object message = null;
    
    try{
      message = dis.readObject();
     }catch(OptionalDataException e){
      System.out.println("recvWFEMessage "+e);
    }catch(ClassNotFoundException e){
      System.out.println("recvWFEMessage "+e);
    }catch(IOException e){
      System.out.println("recvWFEMessage "+e);
    }
    return message;
  }

  
}


