package webflow.modules.LMS;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class Unzip extends Template {
  
  InputPort inport;
  OutputPort outport;
  String message,newmessage;
  String command,editor;
  String disp;
  WFFileDescriptor inFile,outFile;
  String FileName;
  
  public MetaModule initialize() {
    
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    System.err.println("got outport");
    ID outputID = outport.getPortID();
    System.err.println("output port ID :"+ outputID.getInt());
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    System.err.println("got inport");
    ID inputID = inport.getPortID();
    System.err.println("input port ID :"+ inputID.getInt());
    mm.putPortID(inport.getPortID());

    newmessage=null;
    return(mm);
    }
  
  public void run() {
    
    //wait till you know the ip address of the display
    
    while(newmessage==null) {;}
    System.out.println("set display to: "+newmessage);
    disp=newmessage.substring(4);

    while(true)
      {
        outFile = new WFFileDescriptor();  
        inFile = (WFFileDescriptor)inport.receive();
        FileName = inFile.getFileDirectory()+inFile.getFileName(); 
        command = "gunzip "+FileName;
        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	}
        catch (Exception e) {System.out.println("Unzip Error: "+e.toString());}
        if(outport.isConnected()) {
           String unzippedFileName=inFile.getFileName();
           System.out.println("Unzip: "+unzippedFileName); 
           int idx=unzippedFileName.indexOf(".");
           unzippedFileName=unzippedFileName.substring(0,idx);
           outFile.setFileName(unzippedFileName);
           outFile.setFileDirectory(inFile.getFileDirectory());
           outFile.setFileHost(inFile.getFileHost());
           outFile.setFileAttribute(inFile.getFileAttribute());
       	   outport.send(outFile);
	}
      }
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    }
    
    public void stop() {}
    
  public void update_value(String s) {
  System.out.println("Unzip: new message: "+s);
  newmessage = s;
  }  
   

}	
    
    
    
