package webflow.modules.QuantumSimulations;


// $Id: SaveAs.java,v 1.2 1998/04/19 06:48:52 haupt Exp haupt $

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class InputFile extends Template {
  InputPort inport;
  OutputPort outport;
  String targetFileName="/tmp/tmp.txt";
  boolean flag,dirflag;
  WFFileDescriptor outFile;// = new WFFileDescriptor();
  int idx;

  public MetaModule initialize() {
    
    System.err.println("Initialize InputFile");
    CreateServerSocket();
    System.err.println("Socket done InputFile");
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());

    System.err.println("about to end init InputFile");
    return(mm);
    }
  
  public synchronized void run() {
    
    targetFileName="whatever";
    flag=false;
    dirflag=false;

    while(true) {
      try {
             wait(1000);
      } catch (InterruptedException e){;}
        
      /* receive file Content from input port */
      String content  = (String)inport.receive();
       
      /* write to destination */
      writeFile(targetFileName,content);
    }
  }
  
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
      String[] directory_contents=null;
      System.err.println("update_value is CALLED with "+s);
      
      if(s.equals("_make_connection")) {
       System.err.println("CONTROLS1 CONNECTED !!!");
      }
       else if (s.startsWith("SWING_REQ")){
	   System.err.println("I received DIR NAME:"+s);
	   
	   //received directory name for file browser
	   String dir = s.substring("SWING_REQ".length());
	   try{
	     directory_contents = list(dir,"");
	   }catch(InterruptedException e){
	   }
	   send_directory_contents(directory_contents);
	   dirflag = true;
	 }  
	 else if (s.startsWith("SWING_REPLY")){
	   targetFileName=s.substring("SWING_REPLY".length()); 
	   System.err.println("new message arrived: "+targetFileName);
	   flag=true;
	 }
      
    }
    
public void send_directory_contents(String []list)
  {
    
    socket.send(list[0]);
    int nfiles = list.length-1;
    socket.send(Integer.toString(nfiles));
    
    for(int i=1;i<list.length;i++){
//      System.err.println("sent InputFile ="+list[i]);
      socket.send(list[i]);
    }
  }
  

  public  String [] list(String dir,String opts)
         throws InterruptedException
  {
    boolean isExist=false,isRead=false;
    Vector lines = new Vector();

    System.err.println(dir+" is requested "); 
    //insert first requested directory name
    lines.addElement(dir);

    //check that this directory exists first
    File file = new File(dir);
    try{
      if (file.exists())
	isExist = true;
      isRead = true;
    }catch(SecurityException e){
      System.err.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.err.println(dir+" is not readable");
      lines.addElement("total xx");   
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.err.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }
    if ((!isRead)||(!isExist)){
      System.err.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      
      String line;
      String  cmd,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
      cmd = "ls -al "+dir;
      child = Runtime.getRuntime().exec(cmd);
      in = new DataInputStream(child.getInputStream());
      
      //read the command's output
      while((line = in.readLine()) != null)
	lines.addElement(line);

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

}	
    
    
    


