package webflow.modules.demo.io;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.*;
import java.awt.image.*;
import java.lang.*;
import gjt.filter.*;
import java.net.*;
import java.io.*;

/* 
 * This module transmits the image data which it receives from the viewer
 * module
 */

public class InputModule implements Module {

  ImgData imgdat;	
  //InputPort inport;
  OutputPort outport;
  ServerSocket listener;
  Socket aSocket;
  String hostName;
  int portNumber;
  DataInputStream dis;
  DataOutputStream dos;
  Diagnostic diag;
	
  public MetaModule initialize() {
    System.err.println("InputModule: initialize"); 
    // Load the image.
    MetaModule mm = new MetaModule("Input Module ");
    int i;

    outport = new OutputPort("ImgData");
    mm.putPortID(outport.getPortID());
    try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket
      listener = new ServerSocket(0);
      portNumber = listener.getLocalPort();
      System.err.println("listener socket activated");
    }catch(UnknownHostException e){System.err.println(e);}
    catch(IOException e){System.err.println(e);}
// Html Code to Display Applet 

    String htmlString=new String("CODE = \"webflow.modules.demo.io.InputApplet.class\"  WIDTH=300 HEIGHT=300>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;
    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=Input>\n</APPLET>\n</P>\n";
    System.err.println(htmlString);
    mm.setHTML(htmlString);
    System.err.println("out");

     
    System.err.println("done initializing");
    return(mm);	
  }

  public ServerSocket getSocket() { return listener; }

  public void run(){
      System.err.println("InputModule: run");

    try{
      aSocket=listener.accept();
      System.err.println("accepted connection");
      dos= new DataOutputStream(aSocket.getOutputStream());
      dis= new DataInputStream(aSocket.getInputStream());
      String fname= new String("TazzaLogo.gif");
    } catch(IOException e) {System.err.println(e);}
    System.err.println("confirmation 0 will be sent");
    confirm(0);
    System.err.println("confirmation 0 sent");
    

    while(true){
      get();
      System.err.println("image received");
      sendImg();
      confirm(0);
      System.err.println("confirmation 0 sent");
    }
  }	
  
	
  void  get(){
    try{
      int width=dis.readInt();
      int height=dis.readInt();
  
      System.err.println("width = " + width + " height = " + height);
      //      System.out.println("w1 =" + width+"h=" + height);
      byte[] pixels = new byte[height*width*4];
      dis.readFully(pixels,0,width*height*4);
      imgdat= new  ImgData(pixels,width,height);
    } catch(IOException e){System.out.println(e);}	
    
    //System.out.println("Exiting get");
  }		
  
  public void sendImg(){
    // testing only
     System.err.println("Sending image");
//    img.send(imgdat);
    outport.send(imgdat);
    System.err.println("sent image");
  }
  
  public void destroy()
  {
    confirm(1);
    System.err.println("confirmation 1 (die) sent");
    //System.out.println("confirmation 1 (die) sent");
    try{
      
      if(aSocket!=null) 
      {  aSocket.close();
         System.err.println("socket closed");
         //System.out.println(" aSocket is closed");

      } else System.out.println(" aSocket is NULL ");

    } catch(IOException e)
      { System.out.println(e);
        e.printStackTrace(); 
      }

    //if(img!=null) img.destroyPort();
   // if(inport!=null) inport.destroyPort();
    if(outport!=null) outport.destroyPort();
    System.err.println("image port destroyed, terminating");
    //System.out.println("image port destroyed, terminating");
  }

  void 
  confirm(int flag)
  {
    try
    {
       if(dos!=null) 
       {  dos.writeInt(flag);
          //System.out.println(" I wrote "+flag+" to the dos ");
       }// end of if

    } catch(IOException e)
      {  System.out.println(e);
         e.printStackTrace();
      }

  }// end of confirm()
  
  public void stop(){}

 
}



